#include "Application.h"

#include <wx/wfstream.h>
#include "MainFrame.h"


wxIMPLEMENT_APP(Application);

Application::Application()
  : m_config(NULL)
{
}

Application::~Application()
{
}

bool Application::OnInit()
{
  // RtBO f[^[h
  // Windows 7 ł "C:\Users\([U[)\AppData\Roaming\csvview.ini"
  m_configFileName = wxFileConfig::GetLocalFileName(_T("csvview"));
  if (wxFile::Exists(m_configFileName))
  {
    wxFileInputStream file(m_configFileName);
    m_config = new wxFileConfig(file);
  }
  else
  {
    m_config = new wxFileConfig();
  }

  // Ct[𐶐
  MainFrame *pFrame = new MainFrame();
  pFrame->Show();
  return true;
}

int Application::OnExit()
{
  // RtBO f[^Z[u
  wxFileOutputStream file(m_configFileName);
  if (file.IsOk())
  {
    m_config->Save(file);
  }

  delete m_config;

  return wxApp::OnExit();
}

wxConfigBase *Application::GetConfig()
{
  return m_config;
}
