#pragma once

#include <vector>
#include "Progress.h"
#include "GraphProject.h"

//--------------------------------------------------------------------------------
/**
 * CSV t@CɃGNX|[gf[^̏.
 */
struct CSVExportedDataInfo
{
  CSVExportedDataInfo()
    : graphDataIndex(0) { }

  int graphDataIndex;
  wxString headerText;  ///< wb_[ɏޕ.
};

/**
 * CSV t@CɃGNX|[gf[^ꗗ.
 * X f[^, f[^ڂɂKv. łȂꍇ, CSVExporter 
 * G[܂.
 * i[Ă鏇ԂŃf[^GNX|[g邵܂.
 */
typedef std::vector<CSVExportedDataInfo> CSVExportedDataInfoArray;

//--------------------------------------------------------------------------------
/**
 * CSV t@CC|[g̃IvV.
 */
struct CSVExportOption
{
  CSVExportOption()
    : exportDataX(true), exportHeader(true) { }

  /**
   * Ot vWFNg̏񂩂ftHg̃GNX|[g IvVݒ肵܂.
   */
  void SetDefaultFromProject(GraphProject const &proj);

#if !defined(NDEBUG)
  void LogDebug() const;
#endif
  
  bool exportDataX;                       ///< X f[^GNX|[g邩ǂ.
  bool exportHeader;                      ///< wb_[GNX|[g邩ǂ.
  wxString dataXHeaderText;               ///< X f[^̃wb_[.
  CSVExportedDataInfoArray exportedData;  ///< GNX|[gf[^ꗗ.
};

//--------------------------------------------------------------------------------
/**
 * CSV t@C̃GNX|[^[.
 * ۂɂ, Zp[^ύX邱ƂŃXy[X^u؂̌`Ƃ
 * GNX|[gł܂.
 */
class CSVExporter
{
public:
  /**
   * RXgN^.
   * @param fileName GNX|[gt@C.
   * @param project GNX|[gOtvWFNg.
   */
  CSVExporter(wxString const &fileName, GraphProject &project);

  /**
   * CSV t@C̃GNX|[gIvVݒ肵܂.
   */
  void SetOption(CSVExportOption const &option);

  /**
   * CSV t@C̃GNX|[gIvV擾܂.
   */
  void GetOption(CSVExportOption &option) const;

  /**
   * Zp[^ݒ肵܂.
   */
  void SetSeparator(wxUniChar separator);

  /**
   * Zp[^擾܂.
   */
  wxUniChar GetSeparator() const;

  /**
   * CSV t@CGNX|[g܂.
   * Ƃ ResultCode::SUCCESS Ԃ܂.
   * GNX|[gIvV̐ݒ肪łƂ, ResultCode::INVALID_PARAM Ԃ܂.
   * t@C̕ۑɎsƂ, ResultCode::FILE_ERROR Ԃ܂.
   */
  ResultCode Export(ProcContext *pPC);

  /**
   * ŌɔG[̃bZ[W擾܂.
   */
  wxString GetLastErrorMessage() const;

private:
  CSVExporter();
  CSVExporter(CSVExporter const &);
  CSVExporter &operator = (CSVExporter const &);

  ResultCode ExportInternal(Progress *pProgress);
  bool IsOptionValid() const;
  
  GraphProject &m_project;
  wxString m_fileName;
  wxUniChar m_separator;
  CSVExportOption m_option;
  mutable wxString m_err;
};

//--------------------------------------------------------------------------------
