#pragma once

#include "FormDesign.h"
#include "CSVImporter.h"

//------------------------------------------------------------------------
/**
 * CSV t@C C|[g IvV _CAO.
 */
class CSVImportOptionDlg : public CSVImportOptionDlgDesign
{
public:
  explicit CSVImportOptionDlg(wxWindow* parent);
  virtual ~CSVImportOptionDlg();

  /**
   * CSV t@C̏_CAOɔf܂.
   */
  void SetFileInfo(CSVFileInfo const &info);

  /**
   * C|[g IvV_CAOɔf܂.
   */
  void SetImportOption(CSVImportOption const &option);

  /**
   * _CAOC|[g IvV擾܂.
   */
  void GetImportOption(CSVImportOption &option) const;

protected:
  // event handlers
	virtual void SpinCtrlHeaderRows_OnSpinCtrl(wxSpinEvent &event);
	virtual void SpinCtrlDataRows_OnSpinCtrl(wxSpinEvent &event);
  virtual void ListCtrlDataSeries_OnListItemDeselected(wxListEvent &event);
  virtual void ListCtrlDataSeries_OnListItemSelected(wxListEvent &event);
	virtual void ButtonAdd_OnButtonClick(wxCommandEvent &event);
	virtual void ButtonRemove_OnButtonClick(wxCommandEvent &event);
	virtual void ButtonMoveUp_OnButtonClick(wxCommandEvent &event);
	virtual void ButtonMoveDown_OnButtonClick(wxCommandEvent &event);
  virtual void TextCtrlLabel_OnText(wxCommandEvent &event);
  virtual void SpinCtrlXDataColumn_OnSpinCtrl(wxSpinEvent &event);
  virtual void SpinCtrlXStart_OnSpinCtrlDouble(wxSpinDoubleEvent &event);
  virtual void SpinCtrlXInterval_OnSpinCtrlDouble(wxSpinDoubleEvent &event);
  virtual void SpinCtrlYDataColumn_OnSpinCtrl(wxSpinEvent &event);
  virtual void CheckBoxUseDirectVal_OnCheckBox(wxCommandEvent &event);

private:
  // HeaderRows, DataRows  UI ̒lXV܂.
  void UpdateRows();

  // DataSeries ̃XgRg[XV܂.
  void UpdateDataSeries();

  // Label, X Data Column, X Start, X Interval, Y Data Column, Use direct x value XV܂.
  void UpdateDataItem();

private:
  CSVFileInfo m_info;
  CSVImportOption m_option;
};

//------------------------------------------------------------------------
