#pragma once

#include <vector>
#include <wx/wx.h>
#include "Progress.h"
#include "GraphProject.h"

//--------------------------------------------------------------------------------
/**
 * CSV t@C̏.
 */
struct CSVFileInfo
{
  CSVFileInfo()
    : columnCount(0), rowCount(0) { }
  
  wxString fileName;
  int columnCount;
  int rowCount;
};

//--------------------------------------------------------------------------------
/**
 * CSV t@C̃Otf[^̐@.
 */
struct CSVDataSourceInfo
{
  CSVDataSourceInfo()
   : useDataX(false), columnX(0), columnY(0) { }

  bool useDataX;    ///< dataX op邩ǂ.
  GraphDataX dataX; ///< f[^ X.
  int columnX;      ///< X f[^.
  int columnY;      ///< Y f[^.
  wxString label;   ///< x.
};

typedef std::vector<CSVDataSourceInfo> CSVDataSourceInfoArray;

//--------------------------------------------------------------------------------
/**
 * CSV t@CC|[g̃IvV.
 */
struct CSVImportOption
{
  CSVImportOption()
    : headerCount(0), rowCount(0) { }
  
  /**
   * CSV t@C̏񂩂ftHg̃C|[g IvVݒ肵܂.
   */
  void SetDefaultFromFileInfo(CSVFileInfo const &info);

  /**
   * CSV t@C̏񂩂ftHg̃C|[g IvVݒ肵܂.
   * wb_[̍sƑ\Iȃwb_[̍s (ʏ̓f[^̎n܂s̒O) ,
   * IɃxݒ肵܂.
   */
  void SetDefaultFromFileInfo(CSVFileInfo const &info, int headers, wxArrayString const &headerStrings);

#if !defined(NDEBUG)
  void LogDebug() const;
#endif

  int headerCount;                    ///< wb_[Ƃēǂݔ΂s.
  int rowCount;                       ///< f[^Ƃēǂݍލs
  CSVDataSourceInfoArray dataSources; ///< f[^\[X.
};

//--------------------------------------------------------------------------------
/**
 * CSV t@C̃C|[^[.
 */
class CSVImporter
{
public:
  /**
   * RXgN^.
   * @param fileName C|[gt@C.
   * @param project C|[g̃OtvWFNg.
   */
  CSVImporter(wxString const &fileName, GraphProject &project);

  /**
   * t@C擾܂.
   */
  wxString GetFileName() const;

  /**
   * CSV t@C̏ (s, 񐔓) XL܂.
   * IɃftHg̃C|[gIvVݒ肵܂.
   * Ƃ ResultCode::SUCCESS, ǂݍ݂ɎsƂ
   * ResultCode::FILE_ERROR Ԃ܂.
   * fꂽƂ ResultCode::Abort Ԃ܂.
   */
  ResultCode ScanInfo(ProcContext *pPC);

  /**
   * CSV t@C̏擾܂.
   */
  void GetFileInfo(CSVFileInfo &info) const;

  /**
   * CSV t@C̃C|[gIvVݒ肵܂.
   */
  void SetOption(CSVImportOption const &option);

  /**
   * CSV t@C̃C|[gIvV擾܂.
   */
  void GetOption(CSVImportOption &option) const;

  /**
   * C|[gIvVLł邩ǂmF܂.
   */
  bool IsOptionValid() const;

  /**
   * Zp[^ݒ肵܂.
   */
  void SetSeparator(wxUniChar separator);
  
  /**
   * Zp[^擾܂.
   */
  wxUniChar GetSeparator() const;

  /**
   * CSV t@CC|[g܂.
   * Ƃ ResultCode::SUCCESS, ǂݍ݂ɎsƂ
   * ResultCode::FILE_ERROR Ԃ܂.
   * fꂽƂ ResultCode::Abort Ԃ܂.
   */
  ResultCode Import(int mipmapResolution, ProcContext *pPC);

  /**
   * ŌɔG[̃bZ[W擾܂.
   */
  wxString GetLastErrorMessage() const;

private:
  CSVImporter();
  CSVImporter(CSVImporter const &);
  CSVImporter &operator = (CSVImporter const &);

  ResultCode ScanInfoInternal(Progress *pProgress);
  ResultCode ImportInternal(Progress *pProgress);

  // KvƂȂ`FbN܂.
  void CheckRequiredColumn(std::vector<bool> &requiredColumn, bool asDataX, bool asDataY);

  GraphProject &m_project;
  wxString m_fileName;
  wxUniChar m_separator;
  CSVFileInfo m_info;
  CSVImportOption m_option;
  mutable wxString m_err;

  std::vector<GraphDataRefPtr> m_refDataArray;  // Import() ňꎞp.
};

//--------------------------------------------------------------------------------
