#pragma once

#include <vector>
#include <wx/geometry.h>
#include <wx/colour.h>
#include <wx/font.h>
#include <wx/string.h>
#include <cairo.h>
#include <cairo-win32.h>

//--------------------------------------------------------------------------------
/**
 * pX.
 * f[^͎vŊi[܂.
 */
class ClosedPath
{
public:
  /**
   * _ǉ܂.
   */
  void AddPoint(double x, double y) { m_points.push_back(wxPoint2DDouble(x, y)); }

  /**
   * c܂.
   */
  void Expand(double h);

  std::vector<wxPoint2DDouble> const &Points() const { return m_points; } ;

private:
  std::vector<wxPoint2DDouble> m_points;
};

//--------------------------------------------------------------------------------
/**
 * xN^ OtBbNX Cu Cairo ⏕邽߂̃NX.
 * T[tFCXIuWFNgƃReLXgbv܂.
 * foCX ReLXg PDF/PS/SVG/PNG t@Cւ݂̏T|[g܂.
 */
class Cairo
{
public:
  enum
  {
    TYPE_DC, TYPE_PDF, TYPE_PS, TYPE_SVG, TYPE_PNG, TYPE_INVALID
  };
  
  /**
   * Windows ̃foCXReLXgT[tFCX𐶐RXgN^.
   */
  explicit Cairo(HDC dc);

  /**
   * PDF/PS/SVG/PNG t@C֏ރT[tFCX𐶐RXgN^.
   */
  Cairo(wxString const &fileName, double width, double height);

  /**
   * fXgN^.
   */
  ~Cairo();

  /**
   * Fݒ肵܂.
   */
  void SetSourceRGBA(wxColour const &color);

  /**
   * tHgݒ肵܂.
   */
  void SetFont(wxFont const &font);

  /**
   * w肵`ɓ̎w肵ʒuɃeLXg`悵܂.
   */
  void ShowAlignText(double x, double y, double width, double height,
    double alignX, double alignY, wxString const &text);
  
  /**
   * eLXg`悵܂.
   * Cairo ł̓GR[h UTF-8 Ȃ̂, UTF-8 ւ̕ϊ܂.
   */
  void ShowText(wxString const &text);

  /**
   * w肵ʒuɃpbg f[^Of[Vŕ`悵܂.
   */
  void ShowPalette(double x, double y, double width, double height, COLORREF *pPalette, int paletteSize);
  
  /**
   * pXǉ܂.
   */
  void AppendClosedPath(ClosedPath const &path);

  /**
   * T[tFCX̎ނԂ܂.
   */
  int GetType() { return m_type; }

  /**
   * foCXReLXgԂ܂.
   */
  HDC GetDC() { return m_dc; }

  /**
   * Cairo T[tFCXԂ܂.
   */
  cairo_surface_t *GetSurface() { return m_surface; }

  /**
   * Cairo ReLXgԂ܂.
   */
  cairo_t *GetContext() { return m_cr; }
  
  /**
   * GetContext() ̏ȗ`.
   */
  cairo_t * operator () () { return m_cr; }

private:
  // ftHgRXgN^֎~.
  Cairo();

  // Rs[֎~.
  Cairo(Cairo const &);
  Cairo &operator = (Cairo const &);
  
private:
  HDC m_dc;
  cairo_surface_t *m_surface;
  cairo_t *m_cr;
  int m_type;
  wxString m_fileName;
};

//--------------------------------------------------------------------------------