#include "CalculatorDlg.h"

//--------------------------------------------------------------------------------
CalculatorDlg::CalculatorDlg(wxWindow* parent)
  : CalculatorDlgDesign(parent)
{
}

CalculatorDlg::~CalculatorDlg()
{
}

void CalculatorDlg::SetGraphProject(GraphProject *project)
{
  m_proj = project;
  
  m_comboBoxGraph->Clear();
  int count = m_proj->GetCount();
  for (int i = 0; i < count; ++i)
  {
    GraphDataRefPtr graph = m_proj->GetItem(i);
    m_comboBoxGraph->Append(graph->GetLabel());
  }

  // Ō̃OtftHgőI.
  if (count != 0)
  {
    m_comboBoxGraph->SetSelection(m_proj->GetCount() - 1);
  }
}

void CalculatorDlg::SetGraphLabel(wxString const &label)
{
  m_textCtrlLabel->SetValue(label);
}

void CalculatorDlg::SetGraphDataX(GraphDataX const &dataX)
{
  m_spinCtrlXStart->SetValue(dataX.begin);
  m_spinCtrlXInterval->SetValue(dataX.interval);
}

void CalculatorDlg::SetGraphDataSize(int dataSize)
{
  m_spinCtrlDataSize->SetValue(dataSize);
}

void CalculatorDlg::SetFormula(wxString const &formula)
{
  m_textCtrlFormula->SetValue(formula);
}

wxString CalculatorDlg::GetGraphLabel() const
{
  return m_textCtrlLabel->GetValue();
}

GraphDataX CalculatorDlg::GetGraphDataX() const
{
  GraphDataX dataX;
  dataX.begin = m_spinCtrlXStart->GetValue();
  dataX.interval = m_spinCtrlXInterval->GetValue();
  return dataX;
}

int CalculatorDlg::GetGraphDataSize() const
{
  return m_spinCtrlDataSize->GetValue();
}

wxString CalculatorDlg::GetFormula() const
{
  return m_textCtrlFormula->GetValue();
}

void CalculatorDlg::ButtonSetSameSizeAs_OnButtonClick(wxCommandEvent& event)
{
  wxASSERT(m_proj != NULL);

  int sel = m_comboBoxGraph->GetSelection();
  if (sel == -1) return;
  wxASSERT(sel >= 0 && sel < m_proj->GetCount());
  GraphDataRefPtr graph = m_proj->GetItem(sel);
  GraphDataX dataX = graph->GetDataX();
  m_spinCtrlXStart->SetValue(dataX.begin);
  m_spinCtrlXInterval->SetValue(dataX.interval);
  m_spinCtrlDataSize->SetValue(graph->GetCount());
}

void CalculatorDlg::ButtonAdd_OnButtonClick(wxCommandEvent& event)
{
  wxObject *obj = event.GetEventObject();
  wxButton *button = wxDynamicCast(obj, wxButton);

  wxString label = button->GetLabel();

  if (_T("&&&&") == label)
  {
    m_textCtrlFormula->WriteText(_T("&&"));
  }
  else
  {
    m_textCtrlFormula->WriteText(label);
  }

  wxLogDebug("CalculatorDlg::ButtonAdd_OnButtonClick(): label = %s", label);
}

//--------------------------------------------------------------------------------
