#pragma once

#include <random>
#include <wx/string.h>
#include "Base.h"
#include "Formula.h"
#include "Progress.h"
#include "GraphProject.h"

//--------------------------------------------------------------------------------
/**
 * Formula Cup, ɂvZs܂.
 */
class FormulaCalculator
{
public:
  /**
   * RXgN^.
   * @param project vZΏۂ̃OtvWFNg.
   */
  explicit FormulaCalculator(GraphProject &project);

  /**
   * ݒ肵܂.
   */
  void SetFormula(wxString const &formula);

  /**
   * Xݒ肵܂.
   */
  void SetDataX(GraphDataX const &dataX);

  /**
   * f[^TCYݒ肵܂.
   */
  void SetDataCount(int count);

  /**
   * xݒ肵܂.
   */
  void SetLabel(wxString const &label);

  /**
   * 擾܂.
   */
  wxString GetFormula() const;

  /**
   * X擾܂.
   */
  GraphDataX GetDataX() const;

  /**
   * f[^TCY擾܂.
   */
  int GetDataCount() const;

  /**
   * x擾܂.
   */
  wxString GetLabel() const;

  /**
   * p[X܂.
   * @return  Ƃ true, sƂ false Ԃ܂.
   *          sƂ GetLastErrorMessage() ɂG[bZ[W擾܂.
   */
  bool Parse();

  /**
   * vZ, ~bv}bv𐶐, vZʂvWFNgɒǉ܂.
   * Ƃ ResultCode::SUCCESS, fƂ ResultCode::ABORT,
   * mۂłȂƂ ResultCode::MEMORY_ERROR,
   * lZG[ ([Z) Ƃ ResultCode::ARITHMETIC_ERROR,
   * m̗OƂ ResultCode::UNKNOWN_ERROR Ԃ܂.
   */
  ResultCode Calculate(int mipmapResolution, ProcContext *pPC);

  /**
   * ŌɔG[̃bZ[W擾܂.
   */
  wxString GetLastErrorMessage() const;

private:
  // ftHgRXgN^֎~, Rs[֎~
  FormulaCalculator();
  FormulaCalculator(FormulaCalculator const &);
  FormulaCalculator &operator = (FormulaCalculator const &);

  // ̉Zs܂.
  ResultCode CalculateInternal(Progress *pProgress);

  double GetSmallY(double n, double x);
  double GetLargeY(double n, double i);
  double Rand();

  GraphProject &m_project;
  wxString m_formula;
  GraphDataX m_dataX;
  int m_dataCount;
  wxString m_label;
  mutable wxString m_err;

  double m_x, m_i;
  std::mt19937 m_randGen;                       // rand() ֐p̗WFl[^
  std::normal_distribution<double> m_randDist;  // rand() ֐p̗z

  FormulaParser<double>::AstRefPtr m_refAst;

  GraphDataRefPtr m_refData;                    // f[^. Calculate() ֐̈ꎞp.
};

//--------------------------------------------------------------------------------
