#pragma once

#include <wx/wx.h>
#include "FormDesign.h"
#include "GraphProject.h"
#include "GraphRenderer.h"
#include "Observer.h"

//--------------------------------------------------------------------------------
enum
{
  NOTIFY_COORDINATES_ENTER = 1,
  NOTIFY_COORDINATES_LEAVE = 2,
  NOTIFY_COORDINATES_MOVE  = 3
};

/**
 * }EX[V̍Wʒm.
 * GetInt() ̖߂lɂ\n
 * - NOTIFY_COORDINATES_ENTER Ot}EXƂ.
 * - NOTIFY_COORDINATES_LEAVE Otォ}EXoƂ.
 * - NOTIFY_COORDINATES_MOVE  Ot}EXĂƂ.
 */
wxDECLARE_EVENT(wxEVT_COMMAND_NOTIFY_COORDINATES, wxCommandEvent);

//--------------------------------------------------------------------------------
class GraphPanel : public GraphPanelDesign, public Observer
{
public:
  explicit GraphPanel(wxWindow* parent, wxWindowID id = wxID_ANY,
    const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize,
    long style = wxTAB_TRAVERSAL | wxNO_BORDER);
  virtual ~GraphPanel();

  /**
   * `Ώۂ̃vWFNgݒ肵܂.
   * GraphPanel IuU[oƂĐڑ܂.
   * ̐ڑ͐ؒf܂.
   */
  void SetProject(GraphProject *project);

  /**
   * `Ώۂ̃vWFNg擾܂.
   */
  GraphProject *GetProject() const { return m_proj; }

  /**
   * X Y[ݒ肵܂. }EXɂ鋓ς܂.
   */
  void EnableZoomX(bool zoomXEnabled = true) { m_zoomXEnabled = zoomXEnabled; }

  /**
   * Y Y[ݒ肵܂. }EXɂ鋓ς܂.
   */
  void EnableZoomY(bool zoomYEnabled = true) { m_zoomYEnabled = zoomYEnabled; }

  /**
   * }EXzC[ł̊g嗦ݒ肵܂.
   */
  //void SetZoomRate(double zoomRate) { m_zoomRate = zoomRate; }

  bool IsZoomXEnabled() const { return m_zoomXEnabled; }
  bool IsZoomYEnabled() const { return m_zoomYEnabled; }
  //double GetZoomRate() const { return m_zoomRate; }

  /**
   * _OꂽǂmF܂.
   */
  bool IsRenderingCompleted() const { return m_renderingCompleted; }

  /**
   * Ōɕ`悵Ƃ̃CAEg擾܂.
   */
  GraphRenderingLayout GetLastRenderingLayout() const { return m_layout; }

  /**
   * }EXʒuɑΉOt̍W擾܂.
   */
  wxPoint2DDouble GetGraphCoordinates() const { return m_graphCoor; }

protected:
  // event handlers
	virtual void GraphWindow_OnEraseBackground(wxEraseEvent &event);
	virtual void GraphWindow_OnMouseEvents(wxMouseEvent &event);
	virtual void GraphWindow_OnPaint(wxPaintEvent &event);
	virtual void GraphWindow_OnEnterWindow(wxMouseEvent &event);
	virtual void GraphWindow_OnLeaveWindow(wxMouseEvent &event);
	virtual void GraphWindow_OnSetFocus(wxFocusEvent &event);
	virtual void GraphWindow_OnKillFocus(wxFocusEvent &event);

  // ϑΏۂ̒ʒm̃R[obN֐.
  virtual void Update(Observable *sender, ObserverParamBase const &param);

private:
  // CEBhẼXN[o[ݒ肵܂.
  //void SetMainWindowScrollbars();

  // OtvWFNg.
  GraphProject *m_proj;

  // Ot`悳Ă邩ǂ܂.
  bool m_renderingCompleted;

  // _ÕCAEg.
  GraphRenderingLayout m_layout;

  // Y[уXN[̐.
  bool m_zoomXEnabled, m_zoomYEnabled;
  //double m_zoomRate;

  // hbO.
  bool m_leftDown;
  wxPoint m_pt0;
  double m_minX0, m_maxX0, m_minY0, m_maxY0;

  // }EX[V̍Wʒm.
  bool m_isInnerOfGraph;
  wxPoint2DDouble m_graphCoor;
};

//--------------------------------------------------------------------------------
