#include "GraphProject.h"

#include <cfloat>

//--------------------------------------------------------------------------------
static double Round125(double val)
{
  // val ͐̐ł邱
  wxASSERT(val > 0.0);

  // ŏʂ̌c
  double x = 1.0;
  while (val < 1.0)
  {
    val *= 10.0;
    x /= 10.0;
  }
  while (val >= 10.0)
  {
    val /= 10.0;
    x *= 10.0;
  }

  if (val < 1.5)
  {
    return x;         // (0, 1.5) ͈̔͂̒l 1 Ɋۂ߂
  }
  else if (val < 3.5)
  {
    return x * 2.0;   // [1.5, 3.5) ͈̔͂̒l 2 Ɋۂ߂
  }
  else if (val < 7.5)
  {
    return x * 5.0;   // [3.5, 7.5) ͈̔͂̒l 5 Ɋۂ߂
  }
  else
  {
    return x * 10.0;  // [7.5, 10) ͈̔͂̒l 10 Ɋۂ߂
  }
}

static double CalcGridIntervalAutomatically(double dataRange, double plotArea)
{
  if (0.0 == dataRange)
  {
    // f[^ 1 _̂Ƃ
    return 1.0;
  }
  else
  {
    // 50 sNZ (PIXEL_INTERVAL)  1 {x̊ԊuŃObh`悷.
    static int PIXEL_INTERVAL = 50;

    int gridNum = static_cast<int>(::wxRound(plotArea / PIXEL_INTERVAL)) - 1;
    if (gridNum <= 0) return -1.0;

    // ObhԊuvZ
    double interval = Round125(dataRange / gridNum);
    return interval;
  }
}

//--------------------------------------------------------------------------------
GraphProjectPlotProperty::GraphProjectPlotProperty()
  : /*m_proj(NULL),
    m_graphAreaW(1.0), m_graphAreaH(1.0),*/
    m_bgColor(*wxWHITE),
    m_marginT(10.0), m_marginB(50.0), m_marginL(100.0), m_marginR(10.0),
    m_gridXEnabled(true), m_gridYEnabled(true),
    m_graphAreaFrameW(1.0),
    m_graphAreaFrameColor(*wxBLACK),
    m_gridIntervalXAuto(true), m_gridIntervalYAuto(true),
    m_gridIntervalX(-1.0), m_gridIntervalY(-1.0),
    m_gridLineW(0.5),
    m_gridLineColor(*wxLIGHT_GREY),
    m_tickLineLength(10.0),
    m_tickLineW(1.0),
    m_tickLineColor(*wxBLACK),
    m_tickLabelFont(10.0, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL),
    m_tickLabelFontColor(*wxBLACK),
    m_tickLabelPosX(-55.0),
    m_tickLabelPosY(-15.0),
    m_tickLabelFormatX(_T("%.0f")),
    m_tickLabelFormatY(_T("%.2f")),
    m_axisXLabel(_("Time")),
    m_axisYLabel(_("Value")),
    m_axisLabelFont(10.0, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL),
    m_axisLabelFontColor(*wxBLACK),
    m_axisXLabelPosY(-40.0),
    m_axisYLabelPosX(-70.0)
{
}

double GraphProjectPlotProperty::CalcGridIntervalX(GraphProject const &proj, double graphAreaW) const
{
  if (m_gridIntervalXAuto || m_gridIntervalX <= 0.0)  // C^[o[ȉ̂ƂvZ
  {
    double dataRange = proj.GetPlotMaxX() - proj.GetPlotMinX();
    return CalcGridIntervalAutomatically(dataRange, graphAreaW);
  }
  else
  {
    return m_gridIntervalX;
  }
}

double GraphProjectPlotProperty::CalcGridIntervalY(GraphProject const &proj, double graphAreaH) const
{
  if (m_gridIntervalYAuto || m_gridIntervalY <= 0.0)  // C^[o[ȉ̂ƂvZ
  {
    double dataRange = proj.GetPlotMaxY() - proj.GetPlotMinY();
    return CalcGridIntervalAutomatically(dataRange, graphAreaH);
  }
  else
  {
    return m_gridIntervalY;
  }
}

bool GraphProjectPlotProperty::IsEqualTo(GraphProjectPlotProperty const &rhs) const
{
  return
    m_bgColor             == rhs.m_bgColor &&
    m_marginT             == rhs.m_marginT &&
    m_marginB             == rhs.m_marginB &&
    m_marginL             == rhs.m_marginL &&
    m_marginR             == rhs.m_marginR &&
    m_gridXEnabled        == rhs.m_gridXEnabled &&
    m_gridYEnabled        == rhs.m_gridYEnabled &&
    m_graphAreaFrameW     == rhs.m_graphAreaFrameW &&
    m_graphAreaFrameColor == rhs.m_graphAreaFrameColor &&
    m_gridIntervalXAuto   == rhs.m_gridIntervalXAuto &&
    m_gridIntervalYAuto   == rhs.m_gridIntervalYAuto &&
    m_gridIntervalX       == rhs.m_gridIntervalX &&
    m_gridIntervalY       == rhs.m_gridIntervalY &&
    m_gridLineW           == rhs.m_gridLineW &&
    m_gridLineColor       == rhs.m_gridLineColor &&
    m_tickLineLength      == rhs.m_tickLineLength &&
    m_tickLineW           == rhs.m_tickLineW &&
    m_tickLineColor       == rhs.m_tickLineColor &&
    m_tickLabelFont       == rhs.m_tickLabelFont &&
    m_tickLabelFontColor  == rhs.m_tickLabelFontColor &&
    m_tickLabelPosX       == rhs.m_tickLabelPosX &&
    m_tickLabelPosY       == rhs.m_tickLabelPosY &&
    m_tickLabelFormatX    == rhs.m_tickLabelFormatX &&
    m_tickLabelFormatY    == rhs.m_tickLabelFormatY &&
    m_axisXLabel          == rhs.m_axisXLabel &&
    m_axisYLabel          == rhs.m_axisYLabel &&
    m_axisLabelFont       == rhs.m_axisLabelFont &&
    m_axisLabelFontColor  == rhs.m_axisLabelFontColor &&
    m_axisXLabelPosY      == rhs.m_axisXLabelPosY &&
    m_axisYLabelPosX      == rhs.m_axisYLabelPosX;
}

//--------------------------------------------------------------------------------
GraphProject::GraphProject()
  : m_minX(0.0), m_maxX(1.0), m_minY(0.0), m_maxY(1.0),
    m_notifyEnabled(true), m_notifyTemporal(false),
    m_renotifyContent(0)
{
  //m_prop.SetGraphProject(this);
}

GraphProject::~GraphProject()
{
  // ؒf̂, ̃R[h͂Ȃėǂ
  /*for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
  {
    (*i)->Detach(this);
  }*/
}

GraphProjectRefPtr GraphProject::Create()
{
  return GraphProjectRefPtr(new GraphProject);
}

void GraphProject::Append(GraphDataRefPtr refData)
{
  m_data.push_back(refData);
  refData->Attach(this);
  GraphProjectUpdate param(GraphProjectUpdate::DATA_APPENDED);
  NotifyGraphProjectUpdate(param);
}
  
void GraphProject::Remove(int index)
{
  wxASSERT(index >= 0 && index < static_cast<int>(m_data.size()));
  m_data[index]->Detach(this);
  m_data.erase(m_data.begin() + index);
  GraphProjectUpdate param(GraphProjectUpdate::DATA_REMOVED);
  NotifyGraphProjectUpdate(param);
}

GraphDataRefPtr GraphProject::GetItem(int index) const
{
  wxASSERT(index >= 0 && index < static_cast<int>(m_data.size()));
  return m_data[index];
}

void GraphProject::CreateMipmapForResolution(int resolution, ProcContext *pPC)
{
  for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
  {
    (*i)->CreateMipmapForResolution(resolution, pPC);
  }
}

double GraphProject::GetMaxY(bool onlyEnabledData) const
{
  double max = -DBL_MAX;
  for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
  {
    if (onlyEnabledData && !(*i)->IsEnabled())
    {
      continue;
    }
    if (max < (*i)->GetMaxY())
    {
      max = (*i)->GetMaxY();
    }
  }
  return max;
}

double GraphProject::GetMinY(bool onlyEnabledData) const
{
  double min = DBL_MAX;
  for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
  {
    if (onlyEnabledData && !(*i)->IsEnabled())
    {
      continue;
    }
    if (min > (*i)->GetMinY())
    {
      min = (*i)->GetMinY();
    }
  }
  return min;
}

double GraphProject::GetMaxX(bool onlyEnabledData) const
{
  double max = -DBL_MAX;
  for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
  {
    if (onlyEnabledData && !(*i)->IsEnabled())
    {
      continue;
    }
    if (max < (*i)->GetMaxX())
    {
      max = (*i)->GetMaxX();
    }
  }
  return max;
}

double GraphProject::GetMinX(bool onlyEnabledData) const
{
  double min = DBL_MAX;
  for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
  {
    if (onlyEnabledData && !(*i)->IsEnabled())
    {
      continue;
    }
    if (min > (*i)->GetMinX())
    {
      min = (*i)->GetMinX();
    }
  }
  return min;
}

void GraphProject::GetRange(double &minX, double &maxX, double &minY, double &maxY, bool onlyEnabledData) const
{
  minX = GetMinX(onlyEnabledData);
  maxX = GetMaxX(onlyEnabledData);
  minY = GetMinY(onlyEnabledData);
  maxY = GetMaxY(onlyEnabledData);
}

int GraphProject::GetCount() const
{
  return m_data.size();
}

void GraphProject::SetPlotProperty(GraphProjectPlotProperty const &prop)
{
  if (m_prop != prop)
  {
    m_prop = prop;
    GraphProjectUpdate param(GraphProjectUpdate::PROP_UPDATED);
    NotifyGraphProjectUpdate(param);
  }
}

GraphProjectPlotProperty GraphProject::GetPlotProperty() const
{
  return m_prop;
}

void GraphProject::SetDefaultPlotRange(bool directionX, bool directionY, bool onlyEnabledData)
{
  double minX, maxX, minY, maxY;
  GetPlotRange(minX, maxX, minY, maxY);

  if (m_data.empty())
  {
    // f[^ 1 ȂƂ
    if (directionX)
    {
      minX = 0.0;
      maxX = 1.0;
    }
    if (directionY)
    {
      minY = 0.0;
      maxY = 1.0;
    }
  }
  else
  {
    // Lȃf[^邩ǂmF.
    bool hasEnabledData = false;
    for (std::vector<GraphDataRefPtr>::const_iterator i = m_data.begin(); i != m_data.end(); ++i)
    {
      if ((*i)->IsEnabled())
      {
        hasEnabledData = true;
        break;
      }
    }

    if (directionX)
    {
      minX = GetMinX(hasEnabledData && onlyEnabledData);
      maxX = GetMaxX(hasEnabledData && onlyEnabledData);

      if (minX == maxX)
      {
        minX -= 1.0;
        maxX += 1.0;
      }
    }
    if (directionY)
    {
      minY = GetMinY(hasEnabledData && onlyEnabledData);
      maxY = GetMaxY(hasEnabledData && onlyEnabledData);

      if (minY == maxY)
      {
        minY -= 1.0;
        maxY += 1.0;
      }
    }
  }
  
  SetPlotRange(minX, maxX, minY, maxY);
}

double GraphProject::GetPlotMaxY() const
{
  return m_maxY;
}

double GraphProject::GetPlotMinY() const
{
  return m_minY;
}

double GraphProject::GetPlotMaxX() const
{
  return m_maxX;
}

double GraphProject::GetPlotMinX() const
{
  return m_minX;
}

void GraphProject::GetPlotRange(double &minX, double &maxX, double &minY, double &maxY) const
{
  minX = m_minX;
  maxX = m_maxX;
  minY = m_minY;
  maxY = m_maxY;
}

void GraphProject::SetPlotRange(double minX, double maxX, double minY, double maxY)
{
  // f[^ 1 _̂Ƃ͍ŏlƍőlȂ
  wxASSERT(minX <= maxX);
  wxASSERT(minY <= maxY);

  bool updated = false;

  if (m_minX != minX) { m_minX = minX; updated = true; }
  if (m_maxX != maxX) { m_maxX = maxX; updated = true; }
  if (m_minY != minY) { m_minY = minY; updated = true; }
  if (m_maxY != maxY) { m_maxY = maxY; updated = true; }

  if (updated)
  {
    GraphProjectUpdate param(GraphProjectUpdate::RANGE_UPDATED);
    NotifyGraphProjectUpdate(param);
  }
}

void GraphProject::EnableNotify(bool notifyEnabled)
{
  m_notifyEnabled = notifyEnabled;
}

void GraphProject::EnableNotifyTemporal(bool notifyTemporal)
{
  if (!m_notifyTemporal && notifyTemporal)
  {
    // e|[h˗Lɐ؂ւƂ
    m_renotifyContent = 0;
  }
  else if (m_notifyTemporal && !notifyTemporal)
  {
    // e|[hL˖ɐ؂ւƂ
    if (m_renotifyContent != 0)
    {
      GraphProjectUpdate userParam(m_renotifyContent);
      Notify(userParam);
    }
  }
  m_notifyTemporal = notifyTemporal;
}

void GraphProject::ZoomPlotRangeX(double centerX, double zoomX)
{
  double minX, maxX, minY, maxY;
  GetPlotRange(minX, maxX, minY, maxY);
    
  minX = centerX + (minX - centerX) * zoomX;
  maxX = centerX + (maxX - centerX) * zoomX;

  SetPlotRange(minX, maxX, minY, maxY);
}

void GraphProject::ZoomPlotRangeY(double centerY, double zoomY)
{
  double minX, maxX, minY, maxY;
  GetPlotRange(minX, maxX, minY, maxY);

  minY = centerY + (minY - centerY) * zoomY;
  maxY = centerY + (maxY - centerY) * zoomY;

  SetPlotRange(minX, maxX, minY, maxY);
}

void GraphProject::ZoomPlotRangeX(double zoomX)
{
  double minX = GetPlotMinX();
  double maxX = GetPlotMaxX();
  ZoomPlotRangeX((minX + maxX) / 2.0, zoomX);
}

void GraphProject::ZoomPlotRangeY(double zoomY)
{
  double minY = GetPlotMinY();
  double maxY = GetPlotMaxY();
  ZoomPlotRangeY((minY + maxY) / 2.0, zoomY);
}

void GraphProject::Update(Observable *sender, ObserverParamBase const &param)
{
  // Otf[^̍XVe`B܂.
  GraphDataUpdate update;
  if (GetUserParam(param, update))
  {
    GraphData *data = dynamic_cast<GraphData *>(sender);
    wxASSERT(data != NULL);
    
    GraphProjectUpdate paramProxy(GraphProjectUpdate::DATA_UPDATED);
    paramProxy.SetData(data);
    paramProxy.SetDataUpdateDetail(update);
    NotifyGraphProjectUpdate(paramProxy);
  }
}

void GraphProject::NotifyGraphProjectUpdate(GraphProjectUpdate const &userParam)
{
  if (m_notifyEnabled)
  {
    GraphProjectUpdate userParam2 = userParam;
    if (m_notifyTemporal)
    {
      userParam2.SetTemporal();
      if (userParam.IsUpdated(GraphProjectUpdate::PROP_UPDATED) ||
          userParam.IsUpdated(GraphProjectUpdate::RANGE_UPDATED))
      {
        m_renotifyContent |= userParam.Contents();
      }
    }
    Notify(userParam2);
  }
}

//--------------------------------------------------------------------------------
