#pragma once

#include "GraphProject.h"
#include "Cairo.h"

//--------------------------------------------------------------------------------
/**
 * Ot`惌CAEg.
 * `̌ʂ̃CAEgێĂ܂.
 * }EX쎞ɕ`挋ʂ̈ʒu擾Ƃɗp܂.
 */
struct GraphRenderingLayout
{
public:
  GraphRenderingLayout();

  /**
   * EBhẼNCgWOt̍Wɓ_Wϊ܂.
   */
  wxPoint2DDouble TransformClientToGraphPoint(wxPoint const &pt) const;

  /**
   * EBhẼNCgWOt̍Wɋ (xNg) ϊ܂.
   */
  wxPoint2DDouble TransformClientToGraphDistance(wxPoint const &pt) const;

  double clientWidth, clientHeight; // `GA
  wxRect2DDouble rectGraphFrame;    // Otg

  double rangeMinX, rangeMaxX;      // Ot̃vbg͈ (X )
  double rangeMinY, rangeMaxY;      // Ot̃vbg͈ (Y )

  double gridIntervalX, gridIntervalY;  // ObhԊu (X, Y )
};

//--------------------------------------------------------------------------------
/**
 * Ot`NX.
 */
class GraphRenderer
{
public:
  /**
   * RXgN^.
   * @param project         `悷Ot vWFNg.
   */
  explicit GraphRenderer(Cairo &cairo, GraphProject &project);

  /**
   * _Öݒ肵܂.
   * @param width .
   * @param height .
   */
  void SetArea(double width, double height);

  /**
   * _O̕\, xݒ肵܂.
   * @param resolution  X \. -1 Ŏ.
   *                    `悷ۂɗpf[^ |Cg̍ŏl.
   * @param accuracy    `搸x. 1 ōő吸x.
   *                    2 Ńf[^|CgƂȂ܂.
   */
  void SetResolution(int resolution, int accuracy);

  /**
   * Cairo ReLXgɃ_O.
   */
  void Render();
  
  /**
   * `悵Ot̃CAEg擾܂.
   */
  void GetLayout(GraphRenderingLayout &layout);

private:
  // ftHgRXgN^֎~, Rs[֎~
  GraphRenderer();
  GraphRenderer(GraphRenderer const &);
  GraphRenderer & operator = (GraphRenderer const &);

  // vbg͈
  struct PlotRange
  {
    double minX, maxX, minY, maxY;
  };

  // XP[ (Scale), i (Translate) s
  struct STMatrix
  {
    double ConvX(double x) const { return x * sx + tx; }
    double ConvY(double y) const { return y * sy + ty; }

    double sx, sy, tx, ty;
  };

  // Obh̃_O
  void RenderGrid(GraphProjectPlotProperty const &projProp,
    PlotRange const &r, STMatrix const &m, double gw, double gh);
  
  // f[^̃_O
  void RenderData(PlotRange const &r, STMatrix const &m);

  // ڐ̃_O
  void RenderTick(GraphProjectPlotProperty const &projProp,
    PlotRange const &r, STMatrix const &m, double gw, double gh);
  
  // X, Y x̃_O
  void RenderAxisLabel(GraphProjectPlotProperty const &projProp,
    double gw, double gh);

  Cairo &m_cairo;
  GraphProject &m_proj;
  double m_width, m_height;
  int m_resolution, m_accuracy;
  GraphRenderingLayout m_layout;
};

//--------------------------------------------------------------------------------
