#include "ImageSizeSettingDlg.h"

ImageSizeSettingDlg::ImageSizeSettingDlg(wxWindow* parent)
  : ImageSizeSettingDlgDesign(parent),
    m_windowImageWidth(10), m_windowImageHeight(10)
{
}

ImageSizeSettingDlg::~ImageSizeSettingDlg()
{
}

void ImageSizeSettingDlg::SetWindowImageSize(int width, int height)
{
  m_windowImageWidth = width;
  m_windowImageHeight = height;
}

void ImageSizeSettingDlg::SetImageSize(int width, int height)
{
  m_spinCtrlWidth->SetValue(width);
  m_spinCtrlHeight->SetValue(height);
}

void ImageSizeSettingDlg::GetImageSize(int &width, int &height) const
{
  width = m_spinCtrlWidth->GetValue();
  height = m_spinCtrlHeight->GetValue();
}

void ImageSizeSettingDlg::CheckBoxSameAs_OnCheckBox(wxCommandEvent& event)
{
  bool checked = m_checkBoxSameAs->GetValue();
  if (checked)
  {
    m_spinCtrlWidth->SetValue(m_windowImageWidth);
    m_spinCtrlHeight->SetValue(m_windowImageHeight);
  }

  m_spinCtrlWidth->Enable(!checked);
  m_spinCtrlHeight->Enable(!checked);
}
