#include "Observer.h"

#include <wx/debug.h>
#include <algorithm>

//--------------------------------------------------------------------------------
Observer::Observer()
{
}

Observer::~Observer()
{
  while (!m_observables.empty())
  {
    Observable *observable = m_observables.back();
    
    // Detach ֐ OnDetached() Ăяo. 
    observable->Detach(this);
  }
}

void Observer::Update(Observable *sender, ObserverParamBase const &param)
{
}
  
ObservableList const &Observer::GetConnectedObservables() const
{
  return m_observables;
}

void Observer::OnAttached(Observable *observable)
{
  //  ɒǉĂȂƂmF.
  wxASSERT(std::find(m_observables.begin(), m_observables.end(), observable) == m_observables.end());
  
  //  ǉ.
  m_observables.push_back(observable);
}

void Observer::OnDetached(Observable *observable)
{
  //  ɒǉĂ邱ƂmF.
  ObservableList::iterator iter = std::find(m_observables.begin(), m_observables.end(), observable);
  wxASSERT(iter != m_observables.end());
  
  //  폜.
  m_observables.erase(iter);
}

//--------------------------------------------------------------------------------
Observable::Observable()
{
}

Observable::~Observable()
{
  DetachAll();
}

bool Observable::Attach(Observer *observer)
{
  //  ɓIuU[oǉĂȂƂmF܂. 
  ObserverList::iterator iter = std::find(m_observers.begin(), m_observers.end(), observer);
  if (iter != m_observers.end()) return false;

  //  IuU[oǉ܂(QƃJEg͑₵܂). 
  m_observers.push_back(observer);
  observer->OnAttached(this);
  
  return true;
}

bool Observable::Detach(Observer *observer)
{
  //  w肳ꂽIuU[oǉĂ邱ƂmF܂. 
  ObserverList::iterator iter = std::find(m_observers.begin(), m_observers.end(), observer);
  if (iter == m_observers.end()) return false;

  //  IuU[o폜܂(QƃJEg͌炵܂). 
  m_observers.erase(iter);
  observer->OnDetached(this);
  
  return true;
}

void Observable::DetachAll()
{
  for (ObserverList::iterator i = m_observers.begin(); i != m_observers.end(); ++i)
  {
    (*i)->OnDetached(this);
  }
  m_observers.clear();
}

bool Observable::IsAttached(Observer *observer) const
{
  ObserverList::const_iterator iter = std::find(m_observers.begin(), m_observers.end(), observer);
  return (iter != m_observers.end());
}

void Observable::NotifyInternal(ObserverParamBase const &param)
{
  // CXbhĂяoĂ邱ƂmF.
  wxASSERT(wxThread::IsMain());

  for (ObserverList::iterator i = m_observers.begin(); i != m_observers.end(); ++i)
  {
    (*i)->Update(this, param);
  }
}

ObserverList const &Observable::GetConnectedObservers() const
{
  return m_observers;
}

//--------------------------------------------------------------------------------
