#pragma once

#include <memory>
#include "FormDesign.h"
#include "Progress.h"

//--------------------------------------------------------------------------------
class ProgressDlg;

// Cxg̒`
wxDECLARE_EVENT(wxEVT_COMMAND_PROGRESS_COMPLETED, wxThreadEvent);
wxDECLARE_EVENT(wxEVT_COMMAND_PROGRESS_UPDATE_POS, wxThreadEvent);
wxDECLARE_EVENT(wxEVT_COMMAND_PROGRESS_UPDATE_MSG, wxThreadEvent);

//--------------------------------------------------------------------------------
struct ProgressUpdateInfo
{
  ProgressUpdateInfo() : range(100), pos(0) { }

  int range, pos;
};

//--------------------------------------------------------------------------------
/**
 * vOX _CAO\Ƃ̃XbhNX.
 */
class ProgressThread : public wxThread, public Progress
{
public:
  ProgressThread(ProgressDlg *pDlg, std::shared_ptr<ProgressProcBase> proc);
  virtual ~ProgressThread();

  // Entry() o֐ŎsvOXĂяo.
  virtual void UpdateProgress(int pos, int range);
  virtual void UpdateMessage(wxString const &message);

  virtual void SetText(wxString const &text) { }
  virtual void SetRange(int range) { }
  virtual void SetPos(int pos) { }
  virtual bool IsAbortRequested();
  
  // CXbhł ProgressDlg NXĂяo.
  /*ProgressUpdateInfo GetUpdateInfo() const;
  wxString GetMessage() const;*/

protected:
  virtual ExitCode Entry();

private:
  ProgressDlg *m_pDlg;
  std::shared_ptr<ProgressProcBase> m_proc;
  
  /*ProgressUpdateInfo m_updateInfo;
  mutable wxCriticalSection m_updateInfoCS;

  wxString m_message;
  mutable wxCriticalSection m_messageCS;*/
};

//--------------------------------------------------------------------------------
/**
 * vOX _CAO.
 * \code
 * class CSVImporter
 * {
 * public:
 *   bool Import(Progress *pProgress);
 * };
 * 
 * typedef bool RetValue;
 * using namespace std::placeholders;
 *
 * ProgressDlg progressDlg(parent);
 * Importer imp;
 * RetValue ret = progressDlg.ShowModalAndExecute<RetValue>(std::bind<RetValue>(&CSVImporter::Import, std::ref(imp), _1));
 *
 * // ret ɂ, CSVImporter::Import() ̖߂li[.
 *
 * \endcode
 *
 * Ql
 * http://docs.wxwidgets.org/3.0.2/classwx_thread.html
 */
class ProgressDlg : public ProgressDlgDesign, public ProcContext
{
public:
  explicit ProgressDlg(wxWindow* parent);
  virtual ~ProgressDlg();

  /**
   * ShowModal() ̎gp֎~.
   * RunProcWithContext ̑ 2 ɓn܂.
   * ShowModal() ĂяoƃAT[g܂.
   */
  virtual int ShowModal() { wxASSERT(0); return 0; }
  
  virtual void Run(std::shared_ptr<ProgressProcBase> proc);

protected:
  // event handlers
  virtual void OnClose(wxCloseEvent &event);
  virtual void OnIdle(wxIdleEvent &event);
	virtual void OnInitDialog(wxInitDialogEvent &event);
  virtual void OnCancel(wxCommandEvent &event);
  virtual void Thread_OnProgressCompleted(wxThreadEvent &event);
  virtual void Thread_OnProgressUpdatePos(wxThreadEvent &event);
  virtual void Thread_OnProgressUpdateMsg(wxThreadEvent &event);

private:
  // XbhN܂.
  void DoStartThread();

  std::shared_ptr<ProgressProcBase> m_proc;

  ProgressThread *m_pThread;
  mutable wxCriticalSection m_pThreadCS;  // protects the m_pThread pointer

  friend class ProgressThread;
};

//--------------------------------------------------------------------------------
#if !defined(NDEBUG)

// fobOp֐ 0.5 bɃOo͂.
bool DebugProgressFunc(Progress *pProgress);

// fobOp֐ 0.5 bɃOo͂.
bool DebugProgress(ProcContext *pPC);

#endif

//--------------------------------------------------------------------------------
