#pragma once

#include "FormDesign.h"
#include "GraphProject.h"

//--------------------------------------------------------------------------------
class PropertyPanel : public PropertyPanelDesign, public Observer
{
public:
  explicit PropertyPanel(wxWindow *parent, wxWindowID id = wxID_ANY,
    const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize,
    long style = 0);
  virtual ~PropertyPanel();

  /**
   * vpeBҏWΏۂ̃vWFNgݒ肵܂.
   * PropertyPanel IuU[oƂĐڑ܂.
   * ̐ڑ͐ؒf܂.
   */
  void SetProject(GraphProject *project);

  /**
   * vpeBҏWΏۂ̃vWFNg擾܂.
   */
  GraphProject *GetProject() const { return m_proj; }


protected:
  // event handlers
  virtual void ComboBoxTarget_OnComboBox(wxCommandEvent& event);
  void PropGrid_OnChanged(wxPropertyGridEvent &event);
  void PropGrid_OnSelected(wxPropertyGridEvent &event);
  
  // ϑΏۂ̒ʒm̃R[obN֐.
  virtual void Update(Observable *sender, ObserverParamBase const &param);

private:
  enum UpdatePropContent
  {
    UPDATE_ALL,         // ׂẴvpeBXV
    UPDATE_PLOT_RANGE,  // vbg͈͂XV
    UPDATE_PROJ_PROP,   // vWFNgvpeBXV
    UPDATE_GRAPH_PROP   // Otf[^vpeBXV
  };

  // ҏWΏۂR{{bNXAbvf[g܂.
  void UpdateTargetList();

  // vpeBAbvf[g܂.
  void UpdatePropertyList(UpdatePropContent content);

  void ClearPropertyList();
  void AppendProjectProperty();
  void AppendGraphProperty(int index);

  template <typename Value> Value GetPropValue(wxPGProperty *pid);
  template <> bool GetPropValue<bool>(wxPGProperty *pid);
  template <> double GetPropValue<double>(wxPGProperty *pid);
  template <> wxString GetPropValue<wxString>(wxPGProperty *pid);

  // OtvWFNg.
  GraphProject *m_proj;

  // vpeBID
  wxPGProperty *m_pidPlotRangeMinX, *m_pidPlotRangeMaxX;
  wxPGProperty *m_pidPlotRangeMinY, *m_pidPlotRangeMaxY;
  wxPGProperty *m_pidBGColor;
  wxPGProperty *m_pidMarginTop, *m_pidMarginBottom, *m_pidMarginLeft, *m_pidMarginRight;
  wxPGProperty *m_pidFrameLineWidth, *m_pidFrameLineColor;
  wxPGProperty *m_pidGridEnabledX, *m_pidGridEnabledY;
  wxPGProperty *m_pidGridAutoX, *m_pidGridAutoY;
  wxPGProperty *m_pidGridIntervalX, *m_pidGridIntervalY;
  wxPGProperty *m_pidGridLineWidth, *m_pidGridLineColor;
  wxPGProperty *m_pidTickLineLength, *m_pidTickLineWidth, *m_pidTickLineColor;
  wxPGProperty *m_pidTickFont, *m_pidTickFontColor;
  wxPGProperty *m_pidTickPositionX, *m_pidTickPositionY;
  wxPGProperty *m_pidTickFormatX, *m_pidTickFormatY;
  wxPGProperty *m_pidAxisLabelX, *m_pidAxisLabelY;
  wxPGProperty *m_pidAxisFont, *m_pidAxisFontColor;
  wxPGProperty *m_pidAxisPositionX, *m_pidAxisPositionY;

  wxPGProperty *m_pidLabel;
  wxPGProperty *m_pidCurveLineWidth, *m_pidCurveLineColor;

  // vpeBObh̃[U[삪sĂ邱ƂtO
  bool m_propGridUserAction;
};

//--------------------------------------------------------------------------------
